/**
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.scheme.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.xtext.example.mydsl.scheme.Operation;
import org.xtext.example.mydsl.scheme.SchemePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Operation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.OperationImpl#getArit_op <em>Arit op</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.OperationImpl#getLog_op <em>Log op</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.OperationImpl#getRel_op <em>Rel op</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.OperationImpl#getValueUm <em>Value Um</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.OperationImpl#getValueDois <em>Value Dois</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OperationImpl extends CommandImpl implements Operation
{
  /**
   * The default value of the '{@link #getArit_op() <em>Arit op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getArit_op()
   * @generated
   * @ordered
   */
  protected static final String ARIT_OP_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getArit_op() <em>Arit op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getArit_op()
   * @generated
   * @ordered
   */
  protected String arit_op = ARIT_OP_EDEFAULT;

  /**
   * The default value of the '{@link #getLog_op() <em>Log op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLog_op()
   * @generated
   * @ordered
   */
  protected static final String LOG_OP_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getLog_op() <em>Log op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLog_op()
   * @generated
   * @ordered
   */
  protected String log_op = LOG_OP_EDEFAULT;

  /**
   * The default value of the '{@link #getRel_op() <em>Rel op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRel_op()
   * @generated
   * @ordered
   */
  protected static final String REL_OP_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getRel_op() <em>Rel op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRel_op()
   * @generated
   * @ordered
   */
  protected String rel_op = REL_OP_EDEFAULT;

  /**
   * The default value of the '{@link #getValueUm() <em>Value Um</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValueUm()
   * @generated
   * @ordered
   */
  protected static final int VALUE_UM_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getValueUm() <em>Value Um</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValueUm()
   * @generated
   * @ordered
   */
  protected int valueUm = VALUE_UM_EDEFAULT;

  /**
   * The default value of the '{@link #getValueDois() <em>Value Dois</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValueDois()
   * @generated
   * @ordered
   */
  protected static final int VALUE_DOIS_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getValueDois() <em>Value Dois</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValueDois()
   * @generated
   * @ordered
   */
  protected int valueDois = VALUE_DOIS_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OperationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SchemePackage.Literals.OPERATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getArit_op()
  {
    return arit_op;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setArit_op(String newArit_op)
  {
    String oldArit_op = arit_op;
    arit_op = newArit_op;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.OPERATION__ARIT_OP, oldArit_op, arit_op));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getLog_op()
  {
    return log_op;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setLog_op(String newLog_op)
  {
    String oldLog_op = log_op;
    log_op = newLog_op;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.OPERATION__LOG_OP, oldLog_op, log_op));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getRel_op()
  {
    return rel_op;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setRel_op(String newRel_op)
  {
    String oldRel_op = rel_op;
    rel_op = newRel_op;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.OPERATION__REL_OP, oldRel_op, rel_op));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getValueUm()
  {
    return valueUm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setValueUm(int newValueUm)
  {
    int oldValueUm = valueUm;
    valueUm = newValueUm;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.OPERATION__VALUE_UM, oldValueUm, valueUm));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getValueDois()
  {
    return valueDois;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setValueDois(int newValueDois)
  {
    int oldValueDois = valueDois;
    valueDois = newValueDois;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.OPERATION__VALUE_DOIS, oldValueDois, valueDois));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SchemePackage.OPERATION__ARIT_OP:
        return getArit_op();
      case SchemePackage.OPERATION__LOG_OP:
        return getLog_op();
      case SchemePackage.OPERATION__REL_OP:
        return getRel_op();
      case SchemePackage.OPERATION__VALUE_UM:
        return getValueUm();
      case SchemePackage.OPERATION__VALUE_DOIS:
        return getValueDois();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SchemePackage.OPERATION__ARIT_OP:
        setArit_op((String)newValue);
        return;
      case SchemePackage.OPERATION__LOG_OP:
        setLog_op((String)newValue);
        return;
      case SchemePackage.OPERATION__REL_OP:
        setRel_op((String)newValue);
        return;
      case SchemePackage.OPERATION__VALUE_UM:
        setValueUm((Integer)newValue);
        return;
      case SchemePackage.OPERATION__VALUE_DOIS:
        setValueDois((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.OPERATION__ARIT_OP:
        setArit_op(ARIT_OP_EDEFAULT);
        return;
      case SchemePackage.OPERATION__LOG_OP:
        setLog_op(LOG_OP_EDEFAULT);
        return;
      case SchemePackage.OPERATION__REL_OP:
        setRel_op(REL_OP_EDEFAULT);
        return;
      case SchemePackage.OPERATION__VALUE_UM:
        setValueUm(VALUE_UM_EDEFAULT);
        return;
      case SchemePackage.OPERATION__VALUE_DOIS:
        setValueDois(VALUE_DOIS_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.OPERATION__ARIT_OP:
        return ARIT_OP_EDEFAULT == null ? arit_op != null : !ARIT_OP_EDEFAULT.equals(arit_op);
      case SchemePackage.OPERATION__LOG_OP:
        return LOG_OP_EDEFAULT == null ? log_op != null : !LOG_OP_EDEFAULT.equals(log_op);
      case SchemePackage.OPERATION__REL_OP:
        return REL_OP_EDEFAULT == null ? rel_op != null : !REL_OP_EDEFAULT.equals(rel_op);
      case SchemePackage.OPERATION__VALUE_UM:
        return valueUm != VALUE_UM_EDEFAULT;
      case SchemePackage.OPERATION__VALUE_DOIS:
        return valueDois != VALUE_DOIS_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (arit_op: ");
    result.append(arit_op);
    result.append(", log_op: ");
    result.append(log_op);
    result.append(", rel_op: ");
    result.append(rel_op);
    result.append(", valueUm: ");
    result.append(valueUm);
    result.append(", valueDois: ");
    result.append(valueDois);
    result.append(')');
    return result.toString();
  }

} //OperationImpl
